//
// import.c
//

#include <iostream>
#include <fstream>
#include <string>
using namespace std;

#include "dictionary.h"

int main ( int argc, char *argv[] )
{

	Dictionary *dictionary;
	ifstream fin;
	string buff;
	long tally;
	long newwords;

	// heading
	cout << endl
		<< "***********************************" << endl
		<< "NICOLE: Import Utility version 1.0a" << endl
		<< "***********************************" << endl;

	if ( argc == 1 )
	{
		cout << endl
			<<
			"'import' will import a file containing a list of words. Each word must"
			<<
			"be on a new line, and all words must be in capitals otherwise NICOLE"
			<< "won't be able to see them, and the dictionary will be bloated with"
			<< "useless entries. BACKUP your dictionary file before importing!!!" <<
			endl << "Usage:" << endl << "     import filename" << endl << endl;
		exit ( 0 );
	}

	dictionary = new Dictionary;
	tally = 0;
	newwords = 0;

	// open the file input stream
	fin.open ( argv[1] );

	if ( !fin.is_open (  ) )
	{
		//
		// Abort the importing if we can't find the input file
		//
		cerr << "ERROR: Couldn't open file " << argv[1] << " for reading." << endl
			<< "- aborting import." << endl << endl;
		exit ( 0 );
	}

	while ( !fin.eof (  ) )
	{
		fin >> buff;

		if ( buff != "" )						// skip blank entries
		{
			if ( dictionary->add ( buff ) != 0 )
			{
				newwords++;
			}
			if ( ( tally % 499 ) == ( tally / 499 ) )
			{
				// display some kind of progress every 500 words
				cout << tally;
			}
			else if ( ( tally % 100 ) == ( tally / 100 ) )
			{
				// display some kind of progress every 100 words
				cout << ".";
				cout.flush (  );
			}
			tally++;
		}
		buff = "";									// clear the buffer
	}

	cout << endl;
	// close the file input stream
	fin.close (  );

	cout << "Imported " << dictionary->
		count (  ) << " new word(s) to the dictionary" << endl;

	delete dictionary;

	return 0;
}
