//
// matrix.cpp
//

#include <string>
#include <iostream>
#include <deque>
#include <vector>
#include <algorithm>
using namespace std;

#include "matrix.h"
#include "dictionary.h"
#include "vocabulary.h"

/**
 * Initialises the matrix object.
 */
Matrix::Matrix (  )
{
	int i;

	for ( i = 0; i < 5; i++ )
	{
		phrase.push_back ( "*" );
	}
}

/**
 * Adds a single word to the matrix
 * \param w a single word
 */

void Matrix::add_word ( string w )
{
	Dictionary *dict;
	Vocabulary *voc;

	dict = new Dictionary;
	voc = new Vocabulary;

	// first, add this word to the dictionary.  
	dict->add ( w );

	phrase.push_back ( w );
	phrase.pop_front (  );

	voc->add_phrase ( phrase[0], phrase[1], phrase[2], phrase[3], phrase[4] );

	delete voc;
	delete dict;

}

/**
 * Adds a complete sentence to the matrix.
 * \param s the sentence to be added.
 *
 * \bug there is a memory leak in this function somewhere which
 * \bug is overwriting the "filename" locaiton in the dictionary/collection
 * \bug object. I'm too tired to find it tonight..
 */

void Matrix::add_sentence ( string s )
{
	string word = "";
	unsigned int i;

	// append the full stop '.' to the sentence
	s += ".";

	// seperate the sentence into words and pass onto add_word(w)

	for ( i = 0; i < s.length (  ); i++ )
	{
		if ( s.at ( i ) == ' ' )
		{
			add_word ( word );				// add word to matrix
			word = "";
		}
		else
		{
			word += s.at ( i );
		}
	}

	if ( !word.empty (  ) )
	{															// add the last word to the matrix.
		add_word ( word );
	}

//  dump_phrase();  
}

void Matrix::reply_sentence ( string s )
{
	string word = "";
	unsigned int i;

	// seperate the sentence into words and pass onto add_word(w)

	for ( i = 0; i < s.length (  ); i++ )
	{
		if ( s.at ( i ) == ' ' )
		{
			add_word ( word );				// add word to matrix
			word = "";
		}
		else
		{
			word += s.at ( i );
		}
	}

	if ( !word.empty (  ) )
	{															// add the last word to the matrix.
		phrase.push_back ( word );
		phrase.pop_front (  );
	}

//  dump_phrase();  
}

void show_word ( string s )
{
	cout << s << " | ";
}

void Matrix::dump_phrase (  )
{
	cout << "| ";
	for_each ( phrase.begin (  ), phrase.end (  ), show_word );
	cout << endl;
}

bool Matrix::get_phrase ( string * a, string * b, string * c, string * d,
													string * e )
{
	*a = phrase[0];
	*b = phrase[1];
	*c = phrase[2];
	*d = phrase[3];
	*e = phrase[4];
	return true;
}

/**
 * Reset's the matrix (as if we restarted the program
 */

void Matrix::reset (  )
{
	int i;

	for ( i = 0; i < 5; i++ )
	{
		phrase.push_back ( "*" );
		phrase.pop_front (  );
	}
	cout << "** Conversation Thread reset **" << endl;
}

/**
 * Destructs the matrix object.
 */
Matrix::~Matrix (  )
{
}
